System.sioInit(2400)
white=Color.new(255,255,255)
pspimage=Image.createEmpty(480,272)
pspimage:clear()
pspimage:print(20,0,"--- PSP Gravity Sensor ---",white)
screen:blit(0,0,pspimage,0,0,480,272,false)
screen:flip()
buf=""
text=""
n1=0
n2=0
org1=0
org2=0
while true do
  pad=Controls.read()
  if pad:start() then break end
  if pad:triangle() then org1=n1 org2=n2 end
  buf=System.sioRead()
  for i=1,string.len(buf) do
    ch=string.sub(buf,i,i)
    if ch=="\r" or ch=="\n" then
      if string.sub(text,1,1)~=":" then text="" ch="" end
      if string.len(text)>6 then
        n1=tonumber(string.sub(text,2,4))
        n2=tonumber(string.sub(text,5,7))
        if n1~=nil and n2~=nil then
          x=n1-org1
          y=n2-org2
          pspimage:clear()
          pspimage:print(20,0,"--- PSP Gravity Sensor ---",white)
          pspimage:print(30,16,"X="..x,white)
          pspimage:print(130,16,"Y="..y,white)
          pspimage:drawLine(30,30,230,30,white)
          pspimage:drawLine(230,30,230,230,white)
          pspimage:drawLine(230,230,30,230,white)
          pspimage:drawLine(30,230,30,30,white)
          if x<100 and x>-100 and y<100 and y>-100 then
            pspimage:drawLine(x+130-5,-y+130,x+130+5,-y+130,white)
            pspimage:drawLine(x+130,-y+130-5,x+130,-y+130+5,white)
          end
          screen:blit(0,0,pspimage,0,0,480,272,false)
          screen.waitVblankStart()
          screen:flip()
        end
        text=""
        ch=""
      end
    end
    text=text..ch
  end
end
